
#ifndef	VRAMTool_H
#define	VRAMTool_H

#include "_const.h"
#include "BGSmall8Font.h"

#define VRAMBuf ((u16*)(0x06000000))

static u16 *BGSmall8Font16bit=(u16*)&BGSmall8Font[0];

static void VRAM_SetPixel(s32 x,s32 y,u16 data)
{
  u32 dstadr=x+(y*ScreenWidth);
  
  VRAMBuf[dstadr]=data | BIT15;
}

static void VRAM_ClearPixel(s32 x,s32 y)
{
  u32 dstadr=x+(y*ScreenWidth);
  
  VRAMBuf[dstadr]=0;
}

static u16 VRAM_GetPixel(s32 x,s32 y)
{
  u32 dstadr=x+(y*ScreenWidth);
  
  return(VRAMBuf[dstadr] & (~BIT15));
}

static void VRAM_WriteChar(s32 x,s32 y,char c)
{
  u32 lx,ly;
  
  u16 *srcdata=&BGSmall8Font16bit[((u32)c)*8*8];
  
  for(ly=0;ly<8;ly++){
    for(lx=0;lx<8;lx++){
      VRAM_SetPixel(x+lx,y+ly,*srcdata);
      srcdata++;
    }
  }
  
}

static void VRAM_WriteCharFast(s32 x,s32 y,char c)
{
  u32 lx,ly;
  
  u16 *srcdata=&BGSmall8Font16bit[((u32)c)*8*8];
  
  for(ly=0;ly<8;ly++){
    u32 dstadr=(x+0)+((y+ly)*ScreenWidth);
    u16 *dstbuf=&VRAMBuf[dstadr];
    
    for(lx=0;lx<8;lx++){
      *dstbuf=*srcdata | BIT15;
      dstbuf++;
      srcdata++;
    }
  }
  
}

static void VRAM_WriteString(s32 x,s32 y,char *str)
{
  if(str==NULL) return;
  
  while(*str!=char(0)){
    VRAM_WriteCharFast(x,y,*str);
    str++;
    x+=8;
  }
}

static void VRAM_Clear(void)
{
  MemSet16DMA3(0x294c | BIT15,&VRAMBuf[0],256*256*2);
}

#endif
