
#ifndef imfs_h
#define imfs_h

#define IMFS_FilenameLengthMax (64)

#define IMFSTitle "ImplantFilesystem Version0.1"

extern void IMFS_Init(void *_data);
extern u32 IMFS_GetImplantFileCount(void);
extern u32 IMFS_GetStrCRC32Fast(const char *str);
extern u32 IMFS_GetIndexFromFilename(const char *fn);
extern u32 IMFS_GetFilenameSizeFromIndex(u32 idx);
extern u32 IMFS_GetFilenameSizeFromFilename(const char *fn);
extern char* IMFS_GetFilenameFromIndex(u32 idx);
extern char* IMFS_GetFilenameFromFilename(const char *fn);
extern u32 IMFS_GetFileDataSizeFromIndex(u32 idx);
extern u32 IMFS_GetFileDataSizeFromFilename(const char *fn);
extern u8* IMFS_GetFileDataFromIndex(u32 idx);
extern u8* IMFS_GetFileDataFromFilename(const char *fn);

#endif

